#include "global.h"
#define JOYSTICK_PORT1 1
#define JOY_R_PIN 6
#define JOY_L_PIN 4
#define JOY_U_PIN 7
#define JOY_D_PIN 8
#define JOY_C_PIN 5
extern volatile uint8_t state;
extern volatile int flag;
extern volatile uint8_t index;
extern volatile uint8_t f_100ms;
extern volatile uint8_t speed;
volatile int teu=0;
void joystick_init (void)
{
	
	/* set the GPIOs as inputs */
    GPIOSetDir( JOYSTICK_PORT1, JOY_C_PIN, 0 ); // JOY_CENTER
    GPIOSetDir( JOYSTICK_PORT1, JOY_U_PIN, 0 ); // JOY_UP
    GPIOSetDir( JOYSTICK_PORT1, JOY_D_PIN, 0 ); // JOY_DOWN
	
	GPIOPinIntClear(CHANNEL5);
	GPIOPinIntClear(CHANNEL6);
	GPIOPinIntClear(CHANNEL7);
	
	/* Setup the interrupt, seq: portNum, bitPosi, sense = edge, single = both, event*/
	GPIOSetPinInterrupt(CHANNEL5,JOYSTICK_PORT1, JOY_C_PIN ,0,0);
	GPIOSetPinInterrupt(CHANNEL6,JOYSTICK_PORT1, JOY_U_PIN ,0,0);
	GPIOSetPinInterrupt(CHANNEL7,JOYSTICK_PORT1, JOY_D_PIN ,0,0);


	/* Enable the interrupts */
	GPIOPinIntEnable(CHANNEL5, 0 );
	GPIOPinIntEnable(CHANNEL6, 0 );
	GPIOPinIntEnable(CHANNEL7, 0 );
	
}

void PIN_INT5_IRQHandler(void)
{
	uint32_t regVal;
	regVal = GPIOPinIntStatus(CHANNEL5);	
	if(regVal)
	{  
		teu=0;
  speed = 0;
	}		
	
LPC_GPIO_PIN_INT->IST = 0xFFF;
}

void PIN_INT6_IRQHandler(void)
{
	uint32_t regVal;
	regVal = GPIOPinIntStatus(CHANNEL6);
	if(regVal && (teu!=1))
	{ teu=1;
		state = ST_F_BOOST;
	}
	if(regVal && ( state == ST_F_BOOST))
	{
			flag=1;
      state = ST_FORWARD;                          // in forward direction
      LPC_SCT0->STATE_L = index;                   // set initial state
      LPC_SCT0->CTRL_U &= ~(1 << 2);               // unhalt SCT by clearing bit 2 of the CTRL register		
	}
	if(regVal && (state == ST_FORWARD))
	{
		if (f_100ms)                                 // every 100 mseconds
    {
      f_100ms = 0;
      if (speed < pwm_end)       
         {	
           speed ++;                            // increase motor speed
         }
		}
	}
		
LPC_GPIO_PIN_INT->IST = 0xFFF;

}

void PIN_INT7_IRQHandler(void)
{
	uint32_t regVal;
	regVal = GPIOPinIntStatus(CHANNEL7);
	if(regVal&& (state == ST_FORWARD))
	{		
		if (f_100ms)                                 // every 100 mseconds
       {
         f_100ms = 0;
				 if ( speed > 0)            
            {
               speed --;                            // decrease motor speed
            }
			}
	}
	
	LPC_GPIO_PIN_INT->IST = 0xFFF;
}
